| Server IP : 217.160.0.215 / Your IP : 216.73.216.226 Web Server : Apache System : Linux info 3.0 #1337 SMP Tue Jan 01 00:00:00 CEST 2000 all GNU/Linux User : p35818171 ( 3591632) PHP Version : 7.4.33 Disable Function : NONE MySQL : OFF | cURL : ON | WGET : ON | Perl : ON | Python : OFF | Sudo : OFF | Pkexec : OFF Directory : /sbin/ |
Upload File : |
#!/bin/sh -e
if test $# -eq 0
then
echo "usage: $0 shellname [shellname ...]" 1>&2
exit 1
fi
file=/etc/shells
# I want this to be GUARANTEED to be on the same filesystem as $file
tmpfile="${file}.tmp"
otmpfile="${file}.tmp2"
set -o noclobber
cleanup() {
rm -f "$tmpfile" "$otmpfile"
}
trap cleanup EXIT
if ! cat "$file" > "$tmpfile"
then
cat 1>&2 <<EOF
Either another instance of $0 is running, or it was previously interrupted.
Please examine ${tmpfile} to see if it should be moved onto ${file}.
EOF
exit 1
fi
# this is supposed to be reliable, not pretty
for i
do
REALDIR="$(dirname "$(realpath -m "$i")")/$(basename "$i")"
for j in "$i" "$REALDIR"
do
grep -v "^${j}$" "$tmpfile" > "$otmpfile" || true
mv "$otmpfile" "$tmpfile"
done
done
chmod --reference="$file" "$tmpfile"
chown --reference="$file" "$tmpfile"
mv "$tmpfile" "$file"
trap "" EXIT
exit 0